function [ BOD_t ] = BOD_conc_t( k1,v_km,t,BOD_0 )
%Calculation of the solution of the Streeter-Phelps model for the BOD given
% the distance.
% input: 
% - de-okygenation constant (k1)
% - flow velocity of the river (km/day)
% - the distance (km)
% - the initial value of BOD concentration (mg/l = g/m^3).

% REMEBER: convert the velocity into km/day;

%t = dist/v_km;           %days
BOD_t = BOD_0 * exp(-k1*t); %solution of the Streeter-Phelps model for the BOD;

%%%PLOT BOD_t
t_int = [0.2:0.2:50];
N = length(t_int);
BOD = zeros(N,1);

for i = 1:N;
    
BOD(i) = BOD_0 * exp(-k1*t_int(i));
end

figure;
plot (t_int,BOD);
legend ('BOD');
xlabel ('traveltime'); ylabel ('BOD_concentration');

end

