function [ DO_t ] = DO_conc_t( k1,k2,v_km,t,BOD_0, DO_0, DO_sat)
%%Calculation of the solution of the Streeter-Phelps model for the DO given
% the distance.
% input: 
% - de-okygenation constant (k1)
% - the re-aeration constant (k2)
% - flow velocity of the river (km/day)
% - the distance (km) 
% - the initial value of BOD concentration (mg/l = g/m^3) 
% - the initial value of DO concentration (mg/l = g/m^3) 
% - and the value of DO concentration at saturation (DO_SAT).

% REMEBER: convert the velocity into km/day;UNTITLED8 Summary of this function goes here

%t = dist/v_km; %days
DO_t = DO_sat - (DO_sat-DO_0)*exp(-k2*t) + (k1/(k1-k2))* BOD_0 * (exp(-k1*t)- exp(-k2*t)); %%solution of the Streeter-Phelps model for the DO;

%%%PLOT DO_t
t_int = [0.2:0.2:50];
N = length(t_int);
DO = zeros(N,1);

for i = 1:N;
    
DO(i) = DO_sat - (DO_sat-DO_0)*exp(-k2*t_int(i)) + (k1/(k1-k2))* BOD_0 * (exp(-k1*t_int(i))- exp(-k2*t_int(i)));
end

figure;
plot (t_int,DO);
legend ('DO');
xlabel ('traveltime'); ylabel ('DO_concentration');
end

