%%%%Practice 2 (02/10/17)%%%%
%Exercise 3
%%a new pipe for BOD discharge (into the river) should be installed.
%%According to the WQI and cost indicators, find the optimal position
%%(expressed in distance (km) from the origin (km=0)).
%http://gsscienceolympiad.wiki.elanco.net/file/view/WQ_WATER_QUALITY_INDEX.pdf
%http://www.isca.in/rjrs/archive/v2/i10/3.ISCA-RJRS-2013-171.pdf
load river;

%%%%data contained in 'river'
% k1 = 0.84;      %1/hour -- river.k1
% k2 = 18;        %1/hour -- river.k2
% DO_sat = 10.65; %(mgDO/l) -- river.DO_sat
% A_riv = 6;      %m2 -- river.A
% v_riv_km_hr = 3; %km/hr -- river.v

Q_riv = river.A*(((river.v)*1000)/(60*60)); %m3/s
dist_km = 1:1:100;                          %km
t_int = dist_km./river.v;               %1/hour

%%%%% DATA on new discharge %%%%%%%%
BOD_new_disch = 600;  %(mgBOD/l) new discharge to be placed
DO_new_disch = 1;     %(mgDO/l) new discharge to be placed
Q_disch = 8;          %m3/s

%%%% DATA on current conditions nearby the city center (CC)
BOD_0 = 163; %(mgBOD/l)
DO_0 = 3.0;  % (mgDO/l)
%Water Quality index (WQI)--> weights
w_BOD = 0.2;  %weight for BOD indicator (i_qual_BOD)
w_DO = 0.8;   %weight for DO indicator  (i_qual_DO)

%%%%variable initialization%%%%
BOD = ones(100, 100);
DO = ones(100, 100);
i_qual_DO = ones(100, 100);
i_qual_BOD = ones(100, 100);
WQI = ones(100,100);
WQI_ind = ones(100,1);
cost = ones(100,1);

%Simulation of the DO and BOD dynamic along the river using the
%Streeter-Phelps model. The analytical solutions for BOD and DO are used.
%The for cycle "j" refers to the different alterantives (different position of the pipe along the river)
%The for cycle "i" refers to each module in which the river is divided in
%the simulation (one module correspond to a stretch of 1 km).
%Each element "i" can be located before, in correpondance to, or after the pipe (located in "j");
%For this reason, you will find three different ways for calculating the
%BOD and DO concentrations.

for j= 1:100 %distance from the origin (km) - pipe location
    for i=1:100
        if i<j %element "i" located before the pipe
           BOD(i,j) = BOD_0 * exp(-river.k1*t_int(i));
           DO(i,j) = river.DO_sat - (river.DO_sat-DO_0)*exp(-river.k2*t_int(i)) + (river.k1/(river.k1-river.k2))* BOD_0 * (exp(-river.k1*t_int(i))- exp(-river.k2*t_int(i)));
           %%%%%% use functions %%%%%%%
           % BOD(i,j) = BOD_conc_t(river.k1,river.v,t_int(i),BOD_0 )
           % DO(i,j) = DO_conc_t(river.k1, river.k2,river.v,t_int(i),BOD_0, DO_0, river.DO_sat)
        elseif i==j %element "i" located in correspondance of the pipe. A mass balance between the river and the pipe should be computed.
            BOD_riv(i,j) = BOD_0 * exp(-river.k1*t_int(i));
            DO_riv(i,j) = river.DO_sat - (river.DO_sat-DO_0)*exp(-river.k2*t_int(i)) + (river.k1/(river.k1-river.k2))* BOD_0 * (exp(-river.k1*t_int(i))- exp(-river.k2*t_int(i)));
            %%%%%% use functions %%%%%%%
           % BOD(i,j) = BOD_conc_t(river.k1,river.v,t_int(i),BOD_0 )
           % DO(i,j) = DO_conc_t(river.k1, river.k2,river.v,t_int(i),BOD_0, DO_0, river.DO_sat)
            [ BOD_mix, DO_mix ] = mass_balance( Q_riv, BOD_riv(i,j), DO_riv(i,j), Q_disch, BOD_new_disch, DO_new_disch);
            BOD(i,j) = BOD_mix;
            DO(i,j) = DO_mix;
            BOD_0_new = BOD(i,j); %"New initial condition of BOD" for i>j
            DO_0_new = DO(i,j);   %"New initial condition of DO" for i>j
        elseif i>j % %element "i" located after the pipe. The t from the "origin" changes because we are considering "new" BOD and DO concentration as references (=origins).
            BOD(i,j) = BOD_0_new * exp(-river.k1*t_int(i-j));
            DO(i,j) = river.DO_sat - (river.DO_sat-DO_0_new)*exp(-river.k2*t_int(i-j)) + (river.k1/(river.k1-river.k2))* BOD_0_new * (exp(-river.k1*t_int(i-j))- exp(-river.k2*t_int(i-j)));
            %%%%%% use functions %%%%%%%
           % BOD(i,j) = BOD_conc_t(river.k1,river.v,t_int(i-j),BOD_0 )
           % DO(i,j) = DO_conc_t(river.k1, river.k2,river.v,t_int(i-j),BOD_0, DO_0, river.DO_sat)
        end
    %%%%%%- BOD and DO - water quality indicator) -%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
    [i_qual_DO(i,j), i_qual_BOD(i,j)]=quality_ind(DO(i,j), BOD(i,j), river.DO_sat, river.ind_DO_interv, river.ind_BOD_interv, river.ind_DO_param, river.ind_BOD_param);
       
    %Water Quality Index for each element "i" in a given alternative "j" (using w_BOD and w_DO)
    WQI(i,j)= w_DO*i_qual_DO(i,j)+ w_BOD*i_qual_BOD(i,j);
    end
    %Water Quality Index for each alternative "j" (average along the whole
    %river)
    WQI_ind(j)= (sum(WQI(:,j)))/length(WQI);
    %Cost index for each alternative "j"
    cost(j) = 50*(j^(-0.6))+ 60*(j)^0.1; %EXPLAIN THE COST FUNCTION!!(FIRST:the closer to the centre, the more we have to treat the discharge before releasing it; SECOND: cost of infrastructure   
end

 figure; 
 subplot(3,1,1)
 plot(dist_km,WQI_ind,'.-');
 title('Water Quality Indicator')
 xlabel('distance (km)')
 ylabel('WQI')
 subplot(3,1,2)
 plot(dist_km,cost,'.-');
 title('Cost Indicator')
 xlabel('distance (km)')
 ylabel('Cost')

%%
 
[WQI_max_1,I_WQI_1] = max(WQI_ind(:)); %distance for the optimum discharge acoording to the Water Quality Index (which maximizes the WQI)

%Jtot: overall indicator (combination of WQI and cost)
w_cost = 0.77;
w_WQI = 0.23;
Jtot_1 = WQI_ind.*w_WQI - (cost/4).*w_cost;
[Jtot_1_max,I_1] = max(Jtot_1(:));%distance for the optimum discharge acoording to the total Objective (which maximize the total Objective, Jtot)
subplot(3,1,3)
plot(dist_km,Jtot_1);
title('Overall indicator')
xlabel('distance (km)')
ylabel('Jtot')
position_1 = I_1

%%
%%the municipality declares that the suitable location for building the
%discharge can be located only between the 45th and the 55th kilometer.
%
WQI_ind_2 = WQI_ind(45:55);
cost_2 = cost(45:55);
dist_km_2 = dist_km(45:55);
 
 
[WQI_max_2,I_WQI_2] = max(WQI_ind_2(:)); %distance for the optimum discharge acoording to the Water Quality Index (which maximize the WQI)
w_cost = 0.77;
w_WQI = 0.23;
Jtot_2 = WQI_ind_2.*w_WQI - (cost_2/4).*w_cost;
[Jtot_2_max,I_2] = max(Jtot_2(:));%distance for the optimum discharge acoording to the total Objective (which maximize the total Objective, Jtot)
position_2 = I_2 + 45
